/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("deploy.rmps.properties.StereotypesSection");

dojo.require("dijit._Widget");
dojo.require("dojo.i18n");

dojo.require("jazz.ui.StyledTable");

dojo.requireLocalization("deploy.rmps.properties", "StereotypesSectionMessages");

var messages = dojo.i18n.getLocalization("deploy.rmps.properties", "StereotypesSectionMessages");

dojo.declare("deploy.rmps.properties.StereotypesSection", dijit._Widget, {
	
	"class": "deploy-rmps-properties-stereotypesSection",
	
	// mixin properties
	stereotypes: null, //{name: , profileName: , required: }

	postCreate: function() {
		this.containerNode = this.domNode;
		
		var columns = [
			{
				label: messages.column_stereotype
			},
			{
				label: messages.column_profile
			},
			{
				label: messages.column_required
			}
		];
		
		var table = new jazz.ui.StyledTable({
			columns: columns
		});
		
		if (this.stereotypes) {
			
			var lastCategory = null;
			
			for (var i = 0, data; data = this.stereotypes[i]; ++i) {
				// assume data is ordered by category from the server
				if (data.category !== lastCategory) {
					// add category
					table.tbody.appendChild(this._createCategoryRow(data.category));
					lastCategory = data.category;
				}
				table.tbody.appendChild(this._createStereotypeRow(data));
			}
		}
		
		this.domNode.appendChild(table.domNode);
	},
	
	_createCategoryRow: function(category) {
		var tr = dojo.create("tr");
		var categoryCell = dojo.create("td", {"class": "category"}, tr);
		categoryCell.appendChild(dojo.doc.createTextNode(category));
		
		var emptyCell = dojo.create("td", null, tr);
		emptyCell.innerHTML = "&nbsp;";
		
		return tr;
	},
	
	_createStereotypeRow: function(stereotype) {
		var tr = dojo.doc.createElement("tr");
		var nameCell = dojo.create("td", {"class": "label"}, tr);
		var profileCell = dojo.create("td", {"class": "profileName"}, tr);
		var requiredCell = dojo.create("td", {"class": "required"}, tr);
		
		nameCell.appendChild(dojo.doc.createTextNode(stereotype.label || ""));
		profileCell.appendChild(dojo.doc.createTextNode(stereotype.profileName || ""));
		requiredCell.appendChild(dojo.doc.createTextNode(stereotype.required == true));
		
		return tr;
	}
	
});

})();